BatchInserter (Neo4j Community 2.1.0-M01 API)
Date: 2014-02-20

org.neo4j.unsafe.batchinsert

## Interface BatchInserter

- All Known Implementing Classes:
    BatchInserterImpl

      public interface BatchInserter

  The batch inserter drops support for transactions and concurrency in favor of insertion speed. When done using the batch inserter `shutdown()` must be invoked and complete successfully for the Neo4j store to be in consistent state.

  Only one thread at a time may work against the batch inserter, multiple threads performing concurrent access have to employ synchronization.

  Transactions are not supported so if the JVM/machine crashes or you fail to invoke `shutdown()` before JVM exits the Neo4j store can be considered being in non consistent state and the insertion has to be re-done from scratch.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ConstraintCreator` | `createDeferredConstraint(Label label)` Returns a `ConstraintCreator` where details about the constraint can be specified.
    `IndexCreator` | `createDeferredSchemaIndex(Label label)` Returns an `IndexCreator` where details about the index to create can be specified.
    `void` | `createNode(long id, Map<String,Object> properties, Label... labels)` Creates a node with supplied id and properties.
    `long` | `createNode(Map<String,Object> properties, Label... labels)` Creates a node assigning next available id to id and also adds any properties supplied.
    `long` | `createRelationship(long node1, long node2, RelationshipType type, Map<String,Object> properties)` Creates a relationship between two nodes of a specific type.
    `Iterable<Label>` | `getNodeLabels(long node)`
    `Map<String,Object>` | `getNodeProperties(long nodeId)` Returns a map containing all the properties of this node.
    `BatchRelationship` | `getRelationshipById(long relId)` Gets a relationship by id.
    `Iterable<Long>` | `getRelationshipIds(long nodeId)` Returns an iterable over all the relationship ids connected to node with supplied id.
    `Map<String,Object>` | `getRelationshipProperties(long relId)` Returns a map containing all the properties of the relationships.
    `Iterable<BatchRelationship>` | `getRelationships(long nodeId)` Returns an iterable of `relationships` connected to the node with supplied id.
    `String` | `getStoreDir()` Returns the path to this Neo4j store.
    `boolean` | `nodeExists(long nodeId)` Checks if a node with the given id exists.
    `boolean` | `nodeHasLabel(long node, Label label)`
    `boolean` | `nodeHasProperty(long node, String propertyName)` Returns true iff the node with id `node` has a property with name `propertyName`.
    `boolean` | `relationshipHasProperty(long relationship, String propertyName)` Returns true iff the relationship with id `relationship` has a property with name `propertyName`.
    `void` | `removeNodeProperty(long node, String property)` Removes the property named `property` from the node with id `id`, if present.
    `void` | `removeRelationshipProperty(long relationship, String property)` Removes the property named `property` from the relationship with id `id`, if present.
    `void` | `setNodeLabels(long node, Label... labels)` Replaces any existing labels for the given node with the supplied list of labels.
    `void` | `setNodeProperties(long node, Map<String,Object> properties)` Sets the properties of a node.
    `void` | `setNodeProperty(long node, String propertyName, Object propertyValue)` Sets the property with name `propertyName` of node with id `node` to the value `propertyValue`.
    `void` | `setRelationshipProperties(long rel, Map<String,Object> properties)` Sets the properties of a relationship.
    `void` | `setRelationshipProperty(long relationship, String propertyName, Object propertyValue)` Sets the property with name `propertyName` of relationship with id `relationship` to the value `propertyValue`.
    `void` | `shutdown()` Shuts down this batch inserter syncing all changes that are still only in memory to disk.

- - ### Method Detail

    - #### createNode

          long createNode(Map<String,Object> properties,
                        Label... labels)

      Creates a node assigning next available id to id and also adds any properties supplied.
      Parameters:
        `properties` - a map containing properties or `null` if no properties should be added.
        `labels` - a list of labels to initially create the node with.
      Returns:
        The id of the created node.

    - #### createNode

          void createNode(long id,
                        Map<String,Object> properties,
                        Label... labels)

      Creates a node with supplied id and properties. If a node with the given id exist a runtime exception will be thrown.
      Parameters:
        `id` - the id of the node to create.
        `properties` - map containing properties or `null` if no properties should be added.
        `labels` - a list of labels to initially create the node with.

    - #### nodeExists

          boolean nodeExists(long nodeId)

      Checks if a node with the given id exists.
      Parameters:
        `nodeId` - the id of the node.
      Returns:
        `true` if the node exists.

    - #### setNodeProperties

          void setNodeProperties(long node,
                               Map<String,Object> properties)

      Sets the properties of a node. This method will remove any properties already existing and replace it with properties in the supplied map.

      For best performance try supply all the nodes properties upon creation of the node. This method will delete any existing properties so using it together with `getNodeProperties(long)` will have bad performance.

      Parameters:
        `node` - the id of the node.
        `properties` - map containing the properties or `null` to clear all properties.

    - #### nodeHasProperty

          boolean nodeHasProperty(long node,
                                String propertyName)

      Returns true iff the node with id `node` has a property with name `propertyName`.
      Parameters:
        `node` - The node id of the node to check.
        `propertyName` - The property name to check for
      Returns:
        True if the node has the named property - false otherwise.

    - #### setNodeLabels

          void setNodeLabels(long node,
                           Label... labels)

      Replaces any existing labels for the given node with the supplied list of labels.
      Parameters:
        `node` - the node to set labels for.
        `labels` - the labels to set for the node.

    - #### getNodeLabels

          Iterable<Label> getNodeLabels(long node)

      Parameters:
        `node` - the node to get labels for.
      Returns:
        all labels for the given node.

    - #### nodeHasLabel

          boolean nodeHasLabel(long node,
                             Label label)

      Parameters:
        `node` - the node to check.
        `label` - the label to check.
      Returns:
        `true` if a node has a given label, otherwise `false`.

    - #### relationshipHasProperty

          boolean relationshipHasProperty(long relationship,
                                        String propertyName)

      Returns true iff the relationship with id `relationship` has a property with name `propertyName`.
      Parameters:
        `relationship` - The relationship id of the relationship to check.
        `propertyName` - The property name to check for
      Returns:
        True if the relationship has the named property - false otherwise.

    - #### setNodeProperty

          void setNodeProperty(long node,
                             String propertyName,
                             Object propertyValue)

      Sets the property with name `propertyName` of node with id `node` to the value `propertyValue`. If the property exists it is updated, otherwise created.
      Parameters:
        `node` - The node id of the node whose property is to be set
        `propertyName` - The name of the property to set
        `propertyValue` - The value of the property to set

    - #### setRelationshipProperty

          void setRelationshipProperty(long relationship,
                                     String propertyName,
                                     Object propertyValue)

      Sets the property with name `propertyName` of relationship with id `relationship` to the value `propertyValue`. If the property exists it is updated, otherwise created.
      Parameters:
        `relationship` - The node id of the relationship whose property is to be set
        `propertyName` - The name of the property to set
        `propertyValue` - The value of the property to set

    - #### getNodeProperties

          Map<String,Object> getNodeProperties(long nodeId)

      Returns a map containing all the properties of this node.
      Parameters:
        `nodeId` - the id of the node.
      Returns:
        map containing this node's properties.

    - #### getRelationshipIds

          Iterable<Long> getRelationshipIds(long nodeId)

      Returns an iterable over all the relationship ids connected to node with supplied id.
      Parameters:
        `nodeId` - the id of the node.
      Returns:
        iterable over the relationship ids connected to the node.

    - #### getRelationships

          Iterable<BatchRelationship> getRelationships(long nodeId)

      Returns an iterable of `relationships` connected to the node with supplied id.
      Parameters:
        `nodeId` - the id of the node.
      Returns:
        iterable over the relationships connected to the node.

    - #### createRelationship

          long createRelationship(long node1,
                                long node2,
                                RelationshipType type,
                                Map<String,Object> properties)

      Creates a relationship between two nodes of a specific type.
      Parameters:
        `node1` - the start node.
        `node2` - the end node.
        `type` - relationship type.
        `properties` - map containing properties or `null` if no properties should be added.
      Returns:
        the id of the created relationship.

    - #### getRelationshipById

          BatchRelationship getRelationshipById(long relId)

      Gets a relationship by id.
      Parameters:
        `relId` - the relationship id.
      Returns:
        a simple relationship wrapper for the relationship.

    - #### setRelationshipProperties

          void setRelationshipProperties(long rel,
                                       Map<String,Object> properties)

      Sets the properties of a relationship. This method will remove any properties already existing and replace it with properties in the supplied map.

      For best performance try supply all the relationship properties upon creation of the relationship. This method will delete any existing properties so using it together with `getRelationshipProperties(long)` will have bad performance.

      Parameters:
        `rel` - the id of the relationship.
        `properties` - map containing the properties or `null` to clear all properties.

    - #### getRelationshipProperties

          Map<String,Object> getRelationshipProperties(long relId)

      Returns a map containing all the properties of the relationships.
      Parameters:
        `relId` - the id of the relationship.
      Returns:
        map containing the relationship's properties.

    - #### removeNodeProperty

          void removeNodeProperty(long node,
                                String property)

      Removes the property named `property` from the node with id `id`, if present.
      Parameters:
        `node` - The id of the node from which to remove the property
        `property` - The name of the property

    - #### removeRelationshipProperty

          void removeRelationshipProperty(long relationship,
                                        String property)

      Removes the property named `property` from the relationship with id `id`, if present.
      Parameters:
        `relationship` - The id of the relationship from which to remove the property
        `property` - The name of the property

    - #### createDeferredSchemaIndex

          IndexCreator createDeferredSchemaIndex(Label label)

      Returns an `IndexCreator` where details about the index to create can be specified. When all details have been entered `create` must be called for it to actually be created. Creating an index enables indexing for nodes with the specified label. The index will have the details supplied to the `returned index creator`. Indexes created with the method are deferred until the batch inserter is shut down, at which point a background job will populate all indexes, i.e. the index is not available during the batch insertion itself. It is therefore advisable to create deferred indexes just before shutting down the batch inserter.
      Parameters:
        `label` - `label` on nodes to be indexed
      Returns:
        an `IndexCreator` capable of providing details for, as well as creating an index for the given `label`.

    - #### createDeferredConstraint

          ConstraintCreator createDeferredConstraint(Label label)

      Returns a `ConstraintCreator` where details about the constraint can be specified. When all details have been entered `ConstraintCreator.create()` must be called for it to actually be created. Creating a constraint will have the transaction creating it block on commit until all existing data has been verified for compliance. If any existing data doesn't comply with the constraint the transaction will not be able to commit, but fail in `Transaction.close()`.
      Parameters:
        `label` - the label this constraint is for.
      Returns:
        a `ConstraintCreator` capable of providing details for, as well as creating a constraint for the given `label`.

    - #### shutdown

          void shutdown()

      Shuts down this batch inserter syncing all changes that are still only in memory to disk. Failing to invoke this method may leave the Neo4j store in a inconsistent state. Note that this method will trigger population of all indexes, both those created in the batch insertion session, as well as those that existed previously. This may take a long time, depending on data size.

      After this method has been invoked any other method call to this batch inserter is illegal.

    - #### getStoreDir

          String getStoreDir()

      Returns the path to this Neo4j store.
      Returns:
        the path to this Neo4j store.

Copyright © 2002–2014 The Neo4j Graph Database Project. All rights reserved.